Index: branches/HeuristicLab.Problems.GPDL.Backend/HeuristicLab.Problems.GPDL.Backend.sln
===================================================================
--- branches/HeuristicLab.Problems.GPDL.Backend/HeuristicLab.Problems.GPDL.Backend.sln	(revision 10057)
+++ branches/HeuristicLab.Problems.GPDL.Backend/HeuristicLab.Problems.GPDL.Backend.sln	(revision 10059)
@@ -8,28 +8,7 @@
 	EndProjectSection
 EndProject
-Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.Problems.GPDL-3.4", "HeuristicLab.Problems.GPDL\3.4\HeuristicLab.Problems.GPDL-3.4.csproj", "{E4EE5AFB-D552-447B-8A16-6CBE7938AF32}"
-EndProject
-Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "SyntaxAnalyzer", "SyntaxAnalyzer\SyntaxAnalyzer.csproj", "{729B818F-E1D0-4C9D-915A-775B2A4B1D27}"
-EndProject
-Project("{2150E333-8FDC-42A3-9474-1A3956D46DE8}") = "Coco-2", "Coco-2", "{582440C3-BB33-4683-A5EC-673AB51A7AB3}"
-	ProjectSection(SolutionItems) = preProject
-		Coco-2\Errors.cs = Coco-2\Errors.cs
-		Coco-2\Main.frm = Coco-2\Main.frm
-		Coco-2\PGT.exe = Coco-2\PGT.exe
-		Coco-2\PGTSem.frm = Coco-2\PGTSem.frm
-		Coco-2\PGTSyn.frm = Coco-2\PGTSyn.frm
-		Coco-2\Sets.cs = Coco-2\Sets.cs
-		Coco-2\SG.exe = Coco-2\SG.exe
-		Coco-2\SGLex.frm = Coco-2\SGLex.frm
-		Coco-2\Utils.cs = Coco-2\Utils.cs
-	EndProjectSection
-EndProject
 Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.Problems.GPDL.Views-3.4", "HeuristicLab.Problems.GPDL.Views\3.4\HeuristicLab.Problems.GPDL.Views-3.4.csproj", "{3F9E665A-3DCB-49C3-8806-0E47FC48EA52}"
 EndProject
-Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "GpdlCompiler", "GpdlCompiler\GpdlCompiler.csproj", "{C3A2E1C9-9677-4992-A1B7-7B38CDB82FEF}"
-EndProject
 Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "Test", "Test\Test.csproj", "{94073310-27AB-4C93-8FDD-3D35824AE3F7}"
-EndProject
-Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.Grammars-3.3", "HeuristicLab.Grammars\3.3\HeuristicLab.Grammars-3.3.csproj", "{A5452B63-B33B-4F9F-9E81-98B75EDB5612}"
 EndProject
 Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.Problems.GPDL.CodeGen-3.4", "HeuristicLab.Problems.GPDL.CodeGen\3.4\HeuristicLab.Problems.GPDL.CodeGen-3.4.csproj", "{F8481248-2A5B-48A0-A485-D3E1619C1E44}"
@@ -45,24 +24,4 @@
 	EndGlobalSection
 	GlobalSection(ProjectConfigurationPlatforms) = postSolution
-		{E4EE5AFB-D552-447B-8A16-6CBE7938AF32}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
-		{E4EE5AFB-D552-447B-8A16-6CBE7938AF32}.Debug|Any CPU.Build.0 = Debug|Any CPU
-		{E4EE5AFB-D552-447B-8A16-6CBE7938AF32}.Debug|x64.ActiveCfg = Debug|x64
-		{E4EE5AFB-D552-447B-8A16-6CBE7938AF32}.Debug|x64.Build.0 = Debug|x64
-		{E4EE5AFB-D552-447B-8A16-6CBE7938AF32}.Debug|x86.ActiveCfg = Debug|x86
-		{E4EE5AFB-D552-447B-8A16-6CBE7938AF32}.Debug|x86.Build.0 = Debug|x86
-		{E4EE5AFB-D552-447B-8A16-6CBE7938AF32}.Release|Any CPU.ActiveCfg = Release|Any CPU
-		{E4EE5AFB-D552-447B-8A16-6CBE7938AF32}.Release|Any CPU.Build.0 = Release|Any CPU
-		{E4EE5AFB-D552-447B-8A16-6CBE7938AF32}.Release|x64.ActiveCfg = Release|x64
-		{E4EE5AFB-D552-447B-8A16-6CBE7938AF32}.Release|x64.Build.0 = Release|x64
-		{E4EE5AFB-D552-447B-8A16-6CBE7938AF32}.Release|x86.ActiveCfg = Release|x86
-		{E4EE5AFB-D552-447B-8A16-6CBE7938AF32}.Release|x86.Build.0 = Release|x86
-		{729B818F-E1D0-4C9D-915A-775B2A4B1D27}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
-		{729B818F-E1D0-4C9D-915A-775B2A4B1D27}.Debug|Any CPU.Build.0 = Debug|Any CPU
-		{729B818F-E1D0-4C9D-915A-775B2A4B1D27}.Debug|x64.ActiveCfg = Debug|Any CPU
-		{729B818F-E1D0-4C9D-915A-775B2A4B1D27}.Debug|x86.ActiveCfg = Debug|Any CPU
-		{729B818F-E1D0-4C9D-915A-775B2A4B1D27}.Release|Any CPU.ActiveCfg = Release|Any CPU
-		{729B818F-E1D0-4C9D-915A-775B2A4B1D27}.Release|Any CPU.Build.0 = Release|Any CPU
-		{729B818F-E1D0-4C9D-915A-775B2A4B1D27}.Release|x64.ActiveCfg = Release|Any CPU
-		{729B818F-E1D0-4C9D-915A-775B2A4B1D27}.Release|x86.ActiveCfg = Release|Any CPU
 		{3F9E665A-3DCB-49C3-8806-0E47FC48EA52}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
 		{3F9E665A-3DCB-49C3-8806-0E47FC48EA52}.Debug|Any CPU.Build.0 = Debug|Any CPU
@@ -77,12 +36,4 @@
 		{3F9E665A-3DCB-49C3-8806-0E47FC48EA52}.Release|x86.ActiveCfg = Release|x86
 		{3F9E665A-3DCB-49C3-8806-0E47FC48EA52}.Release|x86.Build.0 = Release|x86
-		{C3A2E1C9-9677-4992-A1B7-7B38CDB82FEF}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
-		{C3A2E1C9-9677-4992-A1B7-7B38CDB82FEF}.Debug|Any CPU.Build.0 = Debug|Any CPU
-		{C3A2E1C9-9677-4992-A1B7-7B38CDB82FEF}.Debug|x64.ActiveCfg = Debug|Any CPU
-		{C3A2E1C9-9677-4992-A1B7-7B38CDB82FEF}.Debug|x86.ActiveCfg = Debug|Any CPU
-		{C3A2E1C9-9677-4992-A1B7-7B38CDB82FEF}.Release|Any CPU.ActiveCfg = Release|Any CPU
-		{C3A2E1C9-9677-4992-A1B7-7B38CDB82FEF}.Release|Any CPU.Build.0 = Release|Any CPU
-		{C3A2E1C9-9677-4992-A1B7-7B38CDB82FEF}.Release|x64.ActiveCfg = Release|Any CPU
-		{C3A2E1C9-9677-4992-A1B7-7B38CDB82FEF}.Release|x86.ActiveCfg = Release|Any CPU
 		{94073310-27AB-4C93-8FDD-3D35824AE3F7}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
 		{94073310-27AB-4C93-8FDD-3D35824AE3F7}.Debug|Any CPU.Build.0 = Debug|Any CPU
@@ -93,16 +44,4 @@
 		{94073310-27AB-4C93-8FDD-3D35824AE3F7}.Release|x64.ActiveCfg = Release|Any CPU
 		{94073310-27AB-4C93-8FDD-3D35824AE3F7}.Release|x86.ActiveCfg = Release|Any CPU
-		{A5452B63-B33B-4F9F-9E81-98B75EDB5612}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
-		{A5452B63-B33B-4F9F-9E81-98B75EDB5612}.Debug|Any CPU.Build.0 = Debug|Any CPU
-		{A5452B63-B33B-4F9F-9E81-98B75EDB5612}.Debug|x64.ActiveCfg = Debug|x64
-		{A5452B63-B33B-4F9F-9E81-98B75EDB5612}.Debug|x64.Build.0 = Debug|x64
-		{A5452B63-B33B-4F9F-9E81-98B75EDB5612}.Debug|x86.ActiveCfg = Debug|x86
-		{A5452B63-B33B-4F9F-9E81-98B75EDB5612}.Debug|x86.Build.0 = Debug|x86
-		{A5452B63-B33B-4F9F-9E81-98B75EDB5612}.Release|Any CPU.ActiveCfg = Release|Any CPU
-		{A5452B63-B33B-4F9F-9E81-98B75EDB5612}.Release|Any CPU.Build.0 = Release|Any CPU
-		{A5452B63-B33B-4F9F-9E81-98B75EDB5612}.Release|x64.ActiveCfg = Release|x64
-		{A5452B63-B33B-4F9F-9E81-98B75EDB5612}.Release|x64.Build.0 = Release|x64
-		{A5452B63-B33B-4F9F-9E81-98B75EDB5612}.Release|x86.ActiveCfg = Release|x86
-		{A5452B63-B33B-4F9F-9E81-98B75EDB5612}.Release|x86.Build.0 = Release|x86
 		{F8481248-2A5B-48A0-A485-D3E1619C1E44}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
 		{F8481248-2A5B-48A0-A485-D3E1619C1E44}.Debug|Any CPU.Build.0 = Debug|Any CPU
@@ -121,9 +60,3 @@
 		HideSolutionNode = FALSE
 	EndGlobalSection
-	GlobalSection(NestedProjects) = preSolution
-		{582440C3-BB33-4683-A5EC-673AB51A7AB3} = {3768D612-38EB-47D8-9E79-75D8E5AB00A8}
-	EndGlobalSection
-	GlobalSection(Performance) = preSolution
-		HasPerformanceSessions = true
-	EndGlobalSection
 EndGlobal
Index: branches/HeuristicLab.Problems.GPDL.Backend/HeuristicLab.Problems.GPDL.CodeGen/3.4/HeuristicLab.Problems.GPDL.CodeGen-3.4.csproj
===================================================================
--- branches/HeuristicLab.Problems.GPDL.Backend/HeuristicLab.Problems.GPDL.CodeGen/3.4/HeuristicLab.Problems.GPDL.CodeGen-3.4.csproj	(revision 10057)
+++ branches/HeuristicLab.Problems.GPDL.Backend/HeuristicLab.Problems.GPDL.CodeGen/3.4/HeuristicLab.Problems.GPDL.CodeGen-3.4.csproj	(revision 10059)
@@ -129,4 +129,8 @@
       <HintPath>..\..\..\..\trunk\sources\bin\HeuristicLab.PluginInfrastructure-3.3.dll</HintPath>
     </Reference>
+    <Reference Include="HeuristicLab.Problems.GPDL-3.4, Version=3.4.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL">
+      <SpecificVersion>False</SpecificVersion>
+      <HintPath>..\..\..\HeuristicLab.Problems.GPDL\HeuristicLab.Problems.GPDL\3.4\bin\Debug\HeuristicLab.Problems.GPDL-3.4.dll</HintPath>
+    </Reference>
     <Reference Include="HeuristicLab.Random-3.3, Version=3.3.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL">
       <SpecificVersion>False</SpecificVersion>
@@ -177,10 +181,4 @@
     </BootstrapperPackage>
   </ItemGroup>
-  <ItemGroup>
-    <ProjectReference Include="..\..\HeuristicLab.Problems.GPDL\3.4\HeuristicLab.Problems.GPDL-3.4.csproj">
-      <Project>{e4ee5afb-d552-447b-8a16-6cbe7938af32}</Project>
-      <Name>HeuristicLab.Problems.GPDL-3.4</Name>
-    </ProjectReference>
-  </ItemGroup>
   <Import Project="$(MSBuildToolsPath)\Microsoft.CSharp.targets" />
   <!-- To modify your build process, add your task inside one of the targets below and uncomment it. 
Index: branches/HeuristicLab.Problems.GPDL.Backend/HeuristicLab.Problems.GPDL.Views/3.4/HeuristicLab.Problems.GPDL.Views-3.4.csproj
===================================================================
--- branches/HeuristicLab.Problems.GPDL.Backend/HeuristicLab.Problems.GPDL.Views/3.4/HeuristicLab.Problems.GPDL.Views-3.4.csproj	(revision 10057)
+++ branches/HeuristicLab.Problems.GPDL.Backend/HeuristicLab.Problems.GPDL.Views/3.4/HeuristicLab.Problems.GPDL.Views-3.4.csproj	(revision 10059)
@@ -141,4 +141,8 @@
       <Private>False</Private>
     </Reference>
+    <Reference Include="HeuristicLab.Problems.GPDL-3.4, Version=3.4.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL">
+      <SpecificVersion>False</SpecificVersion>
+      <HintPath>..\..\..\..\trunk\sources\bin\HeuristicLab.Problems.GPDL-3.4.dll</HintPath>
+    </Reference>
     <Reference Include="HeuristicLab.Problems.Instances-3.3, Version=3.3.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL">
       <SpecificVersion>False</SpecificVersion>
@@ -259,11 +263,4 @@
   </ItemGroup>
   <ItemGroup>
-    <ProjectReference Include="..\..\HeuristicLab.Problems.GPDL\3.4\HeuristicLab.Problems.GPDL-3.4.csproj">
-      <Project>{E4EE5AFB-D552-447B-8A16-6CBE7938AF32}</Project>
-      <Name>HeuristicLab.Problems.GPDL-3.4</Name>
-      <Private>False</Private>
-    </ProjectReference>
-  </ItemGroup>
-  <ItemGroup>
     <Page Include="CodeEditor.xaml">
       <SubType>Designer</SubType>
@@ -278,4 +275,10 @@
     <None Include="Resources\Multiplexer.txt" />
     <None Include="Resources\EvenParity.txt" />
+  </ItemGroup>
+  <ItemGroup>
+    <ProjectReference Include="..\..\HeuristicLab.Problems.GPDL.CodeGen\3.4\HeuristicLab.Problems.GPDL.CodeGen-3.4.csproj">
+      <Project>{F8481248-2A5B-48A0-A485-D3E1619C1E44}</Project>
+      <Name>HeuristicLab.Problems.GPDL.CodeGen-3.4</Name>
+    </ProjectReference>
   </ItemGroup>
   <Import Project="$(MSBuildToolsPath)\Microsoft.CSharp.targets" />
Index: branches/HeuristicLab.Problems.GPDL.Backend/Test/Test.csproj
===================================================================
--- branches/HeuristicLab.Problems.GPDL.Backend/Test/Test.csproj	(revision 10057)
+++ branches/HeuristicLab.Problems.GPDL.Backend/Test/Test.csproj	(revision 10059)
@@ -87,4 +87,8 @@
       <Private>True</Private>
     </Reference>
+    <Reference Include="HeuristicLab.Problems.GPDL-3.4, Version=3.4.0.0, Culture=neutral, PublicKeyToken=ba48961d6f65dcec, processorArchitecture=MSIL">
+      <SpecificVersion>False</SpecificVersion>
+      <HintPath>..\..\..\trunk\sources\bin\HeuristicLab.Problems.GPDL-3.4.dll</HintPath>
+    </Reference>
     <Reference Include="HeuristicLab.Problems.Instances-3.3">
       <HintPath>..\..\..\trunk\sources\bin\HeuristicLab.Problems.Instances-3.3.dll</HintPath>
@@ -118,29 +122,16 @@
   </Choose>
   <ItemGroup>
-    <Compile Include="TestGrammar.cs" />
-    <Compile Include="TestGpdlCompiler.cs" />
     <Compile Include="Properties\AssemblyInfo.cs" />
+    <Compile Include="TestGpdlExamples.cs" />
   </ItemGroup>
   <ItemGroup>
-    <ProjectReference Include="..\HeuristicLab.Grammars\3.3\HeuristicLab.Grammars-3.3.csproj">
-      <Project>{a5452b63-b33b-4f9f-9e81-98b75edb5612}</Project>
-      <Name>HeuristicLab.Grammars-3.3</Name>
+    <ProjectReference Include="..\HeuristicLab.Problems.GPDL.CodeGen\3.4\HeuristicLab.Problems.GPDL.CodeGen-3.4.csproj">
+      <Project>{f8481248-2a5b-48a0-a485-d3e1619c1e44}</Project>
+      <Name>HeuristicLab.Problems.GPDL.CodeGen-3.4</Name>
     </ProjectReference>
-    <ProjectReference Include="..\HeuristicLab.Problems.GPDL\3.4\HeuristicLab.Problems.GPDL-3.4.csproj">
-      <Project>{E4EE5AFB-D552-447B-8A16-6CBE7938AF32}</Project>
-      <Name>HeuristicLab.Problems.GPDL-3.4</Name>
-      <Private>True</Private>
+    <ProjectReference Include="..\HeuristicLab.Problems.GPDL.Views\3.4\HeuristicLab.Problems.GPDL.Views-3.4.csproj">
+      <Project>{3f9e665a-3dcb-49c3-8806-0e47fc48ea52}</Project>
+      <Name>HeuristicLab.Problems.GPDL.Views-3.4</Name>
     </ProjectReference>
-  </ItemGroup>
-  <ItemGroup>
-    <None Include="NoNonTerminal.gpdl">
-      <CopyToOutputDirectory>Always</CopyToOutputDirectory>
-    </None>
-    <None Include="MissingRule.gpdl">
-      <CopyToOutputDirectory>Always</CopyToOutputDirectory>
-    </None>
-    <None Include="DupSymbol.gpdl">
-      <CopyToOutputDirectory>Always</CopyToOutputDirectory>
-    </None>
   </ItemGroup>
   <Choose>