Index: /branches/GrammaticalEvolution/HeuristicLab.Problems.GrammaticalEvolution/GEArtificialAntEvaluator.cs
===================================================================
--- /branches/GrammaticalEvolution/HeuristicLab.Problems.GrammaticalEvolution/GEArtificialAntEvaluator.cs	(revision 10067)
+++ /branches/GrammaticalEvolution/HeuristicLab.Problems.GrammaticalEvolution/GEArtificialAntEvaluator.cs	(revision 10068)
@@ -23,11 +23,11 @@
 using HeuristicLab.Core;
 using HeuristicLab.Data;
+using HeuristicLab.Encodings.IntegerVectorEncoding;
 using HeuristicLab.Encodings.SymbolicExpressionTreeEncoding;
-using HeuristicLab.Problems.ArtificialAnt;
 using HeuristicLab.Operators;
 using HeuristicLab.Optimization;
 using HeuristicLab.Parameters;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
-using HeuristicLab.Encodings.IntegerVectorEncoding;
+using HeuristicLab.Problems.ArtificialAnt;
 using HeuristicLab.Problems.GrammaticalEvolution.Mappers;
 
@@ -38,13 +38,13 @@
     ISingleObjectiveEvaluator, ISymbolicExpressionTreeGrammarBasedOperator {
 
-  	#region Parameter Properties
+    #region Parameter Properties
     public ILookupParameter<DoubleValue> QualityParameter {
       get { return (ILookupParameter<DoubleValue>)Parameters["Quality"]; }
     }
-  	// genotype:
-  	public ILookupParameter<IntegerVector> IntegerVectorParameter {
+    // genotype:
+    public ILookupParameter<IntegerVector> IntegerVectorParameter {
       get { return (ILookupParameter<IntegerVector>)Parameters["IntegerVector"]; }
     }
-  	// phenotype:
+    // phenotype:
     public ILookupParameter<SymbolicExpressionTree> SymbolicExpressionTreeParameter {
       get { return (ILookupParameter<SymbolicExpressionTree>)Parameters["SymbolicExpressionTree"]; }
@@ -56,13 +56,13 @@
       get { return (ILookupParameter<IntValue>)Parameters["MaxTimeSteps"]; }
     }
-  	public IValueLookupParameter<ISymbolicExpressionGrammar> SymbolicExpressionTreeGrammarParameter {
+    public IValueLookupParameter<ISymbolicExpressionGrammar> SymbolicExpressionTreeGrammarParameter {
       get { return (IValueLookupParameter<ISymbolicExpressionGrammar>)Parameters["SymbolicExpressionTreeGrammar"]; }
     }
-  	// genotype-to-phenotype-mapper:
-  	public ILookupParameter<IGenotypeToPhenotypeMapper> GenotypeToPhenotypeMapperParameter {
+    // genotype-to-phenotype-mapper:
+    public ILookupParameter<IGenotypeToPhenotypeMapper> GenotypeToPhenotypeMapperParameter {
       get { return (ILookupParameter<IGenotypeToPhenotypeMapper>)Parameters["GenotypeToPhenotypeMapper"]; }
     }
-	  #endregion
-	
+    #endregion
+
     [StorableConstructor]
     protected GEArtificialAntEvaluator(bool deserializing) : base(deserializing) { }
@@ -81,16 +81,16 @@
 
     public sealed override IOperation Apply() {
-      SymbolicExpressionTree expression = GenotypeToPhenotypeMapperParameter.ActualValue.Map (
+      SymbolicExpressionTree expression = GenotypeToPhenotypeMapperParameter.ActualValue.Map(
         SymbolicExpressionTreeGrammarParameter.ActualValue,
-        IntegerVectorParameter.ActualValue        
+        IntegerVectorParameter.ActualValue
       );
       SymbolicExpressionTreeParameter.ActualValue = expression;
       BoolMatrix world = WorldParameter.ActualValue;
       IntValue maxTimeSteps = MaxTimeStepsParameter.ActualValue;
- 
+
       AntInterpreter interpreter = new AntInterpreter();
-      interpreter.MaxTimeSteps   = maxTimeSteps.Value;
-      interpreter.World          = world;
-      interpreter.Expression     = expression;
+      interpreter.MaxTimeSteps = maxTimeSteps.Value;
+      interpreter.World = world;
+      interpreter.Expression = expression;
       interpreter.Run();
 
Index: /branches/GrammaticalEvolution/HeuristicLab.Problems.GrammaticalEvolution/GEArtificialAntProblem.cs
===================================================================
--- /branches/GrammaticalEvolution/HeuristicLab.Problems.GrammaticalEvolution/GEArtificialAntProblem.cs	(revision 10067)
+++ /branches/GrammaticalEvolution/HeuristicLab.Problems.GrammaticalEvolution/GEArtificialAntProblem.cs	(revision 10068)
@@ -42,5 +42,5 @@
   public sealed class GEArtificialAntProblem : SingleObjectiveHeuristicOptimizationProblem<GEArtificialAntEvaluator, IIntegerVectorCreator>, IStorableContent {
     public string Filename { get; set; }
-    
+
     #region constant for default world (Santa Fe)
     private readonly bool[,] santaFeAntTrail = new bool[,] {
@@ -87,10 +87,4 @@
       get { return (IValueParameter<IntValue>)Parameters["MaximumExpressionLength"]; }
     }
-    public IValueParameter<IntValue> MaxFunctionDefinitionsParameter {
-      get { return (IValueParameter<IntValue>)Parameters["MaximumFunctionDefinitions"]; }
-    }
-    public IValueParameter<IntValue> MaxFunctionArgumentsParameter {
-      get { return (ValueParameter<IntValue>)Parameters["MaximumFunctionArguments"]; }
-    }
     public IValueParameter<BoolMatrix> WorldParameter {
       get { return (IValueParameter<BoolMatrix>)Parameters["World"]; }
@@ -119,12 +113,4 @@
       get { return MaxExpressionLengthParameter.Value; }
       set { MaxExpressionLengthParameter.Value = value; }
-    }
-    public IntValue MaxFunctionDefinitions {
-      get { return MaxFunctionDefinitionsParameter.Value; }
-      set { MaxFunctionDefinitionsParameter.Value = value; }
-    }
-    public IntValue MaxFunctionArguments {
-      get { return MaxFunctionArgumentsParameter.Value; }
-      set { MaxFunctionArgumentsParameter.Value = value; }
     }
     public ArtificialAntExpressionGrammar ArtificialAntExpressionGrammar {
@@ -164,29 +150,29 @@
       RegisterEventHandlers();
     }
+
     public override IDeepCloneable Clone(Cloner cloner) {
       return new GEArtificialAntProblem(this, cloner);
     }
+
     public GEArtificialAntProblem()
       : base(new GEArtificialAntEvaluator(), new UniformRandomIntegerVectorCreator()) {
       BoolMatrix world = new BoolMatrix(santaFeAntTrail);
       Parameters.Add(new ValueParameter<IntValue>("MaximumExpressionLength", "Maximal length of the expression to control the artificial ant.", new IntValue(30)));
-      Parameters.Add(new ValueParameter<IntValue>("MaximumFunctionDefinitions", "Maximal number of automatically defined functions in the expression to control the artificial ant.", new IntValue(3)));
-      Parameters.Add(new ValueParameter<IntValue>("MaximumFunctionArguments", "Maximal number of arguments of automatically defined functions in the expression to control the artificial ant.", new IntValue(3)));
       Parameters.Add(new ValueParameter<ISymbolicExpressionGrammar>("ArtificialAntExpressionGrammar", "The grammar that should be used for artificial ant expressions.", new ArtificialAntExpressionGrammar()));
       Parameters.Add(new ValueParameter<BoolMatrix>("World", "The world for the artificial ant with scattered food items.", world));
       Parameters.Add(new ValueParameter<IntValue>("MaximumTimeSteps", "The number of time steps the artificial ant has available to collect all food items.", new IntValue(600)));
-      IntMatrix m = new IntMatrix(new int[,]{{0,100}});
+      IntMatrix m = new IntMatrix(new int[,] { { 0, 100 } });
       Parameters.Add(new ValueParameter<IntMatrix>("Bounds", "The integer number range in which the single genomes of a genotype are created.", m));
       Parameters.Add(new ValueParameter<IGenotypeToPhenotypeMapper>("GenotypeToPhenotypeMapper", "Maps the genotype (an integer vector) to the phenotype (a symbolic expression tree).", new DepthFirstMapper()));
-      
+
       Maximization.Value = true;
       MaximizationParameter.Hidden = true;
       BestKnownQuality = new DoubleValue(89);
-      
+
       SolutionCreator.IntegerVectorParameter.ActualName = "AntTrailSolutionIntegerVector";
       Evaluator.SymbolicExpressionTreeParameter.ActualName = "AntTrailSolutionTree";
       Evaluator.SymbolicExpressionTreeGrammarParameter.ActualName = "ArtificialAntExpressionGrammar";
       Evaluator.QualityParameter.ActualName = "FoodEaten";
-      
+
       InitializeOperators();
       RegisterEventHandlers();
@@ -196,42 +182,42 @@
     protected override void OnSolutionCreatorChanged() {
       base.OnSolutionCreatorChanged();
-      
+
       SolutionCreator.IntegerVectorParameter.ActualName = "AntTrailSolutionIntegerVector";
       SolutionCreator.IntegerVectorParameter.ActualNameChanged += new EventHandler(SolutionCreator_IntegerVectorParameter_ActualNameChanged);
-      
-      ParameterizeAnalyzers();
-      ParameterizeOperators();
-    }
-    
+
+      ParameterizeAnalyzers();
+      ParameterizeOperators();
+    }
+
     protected override void OnEvaluatorChanged() {
       base.OnEvaluatorChanged();
-      
+
       Evaluator.SymbolicExpressionTreeParameter.ActualName = "AntTrailSolutionTree";
       Evaluator.SymbolicExpressionTreeGrammarParameter.ActualName = "ArtificialAntExpressionGrammar";
       Evaluator.QualityParameter.ActualName = "FoodEaten";
-      
+
       Evaluator.SymbolicExpressionTreeParameter.ActualNameChanged += new EventHandler(Evaluator_SymbolicExpressionTreeParameter_ActualNameChanged);
       Evaluator.SymbolicExpressionTreeGrammarParameter.ActualNameChanged += new EventHandler(Evaluator_SymbolicExpressionTreeGrammarParameter_ActualNameChanged);
       Evaluator.QualityParameter.ActualNameChanged += new EventHandler(Evaluator_QualityParameter_ActualNameChanged);
-      
-      ParameterizeAnalyzers();
-      ParameterizeOperators();
-    }
-    
+
+      ParameterizeAnalyzers();
+      ParameterizeOperators();
+    }
+
     private void SolutionCreator_IntegerVectorParameter_ActualNameChanged(object sender, EventArgs e) {
       ParameterizeAnalyzers();
       ParameterizeOperators();
     }
-   
+
     private void Evaluator_SymbolicExpressionTreeParameter_ActualNameChanged(object sender, EventArgs e) {
       ParameterizeAnalyzers();
       ParameterizeOperators();
     }
-    
+
     private void Evaluator_SymbolicExpressionTreeGrammarParameter_ActualNameChanged(object sender, EventArgs e) {
       ParameterizeAnalyzers();
       ParameterizeOperators();
     }
-    
+
     private void Evaluator_QualityParameter_ActualNameChanged(object sender, EventArgs e) {
       ParameterizeAnalyzers();
@@ -242,23 +228,8 @@
     #region Helpers
     private void RegisterEventHandlers() {
-      SolutionCreator.IntegerVectorParameter.ActualNameChanged           += new EventHandler(SolutionCreator_IntegerVectorParameter_ActualNameChanged);
-      Evaluator.SymbolicExpressionTreeParameter.ActualNameChanged        += new EventHandler(Evaluator_SymbolicExpressionTreeParameter_ActualNameChanged);
+      SolutionCreator.IntegerVectorParameter.ActualNameChanged += new EventHandler(SolutionCreator_IntegerVectorParameter_ActualNameChanged);
+      Evaluator.SymbolicExpressionTreeParameter.ActualNameChanged += new EventHandler(Evaluator_SymbolicExpressionTreeParameter_ActualNameChanged);
       Evaluator.SymbolicExpressionTreeGrammarParameter.ActualNameChanged += new EventHandler(Evaluator_SymbolicExpressionTreeGrammarParameter_ActualNameChanged);
       Evaluator.QualityParameter.ActualNameChanged += new EventHandler(Evaluator_QualityParameter_ActualNameChanged);
-      MaxFunctionArgumentsParameter.ValueChanged   += new EventHandler(MaxFunctionArgumentsParameter_ValueChanged);
-      MaxFunctionArguments.ValueChanged            += new EventHandler(MaxFunctionArgumentsParameter_ValueChanged);
-      MaxFunctionDefinitionsParameter.ValueChanged += new EventHandler(MaxFunctionDefinitionsParameter_ValueChanged);
-      MaxFunctionDefinitions.ValueChanged          += new EventHandler(MaxFunctionDefinitionsParameter_ValueChanged);
-    }
-
-    private void MaxFunctionDefinitionsParameter_ValueChanged(object sender, EventArgs e) {
-      ArtificialAntExpressionGrammar.MaximumFunctionDefinitions = MaxFunctionDefinitions.Value;
-      ParameterizeOperators();
-      ParameterizeAnalyzers();
-    }
-    private void MaxFunctionArgumentsParameter_ValueChanged(object sender, EventArgs e) {
-      ArtificialAntExpressionGrammar.MaximumFunctionArguments = MaxFunctionArguments.Value;
-      ParameterizeOperators();
-      ParameterizeAnalyzers();
     }
 
Index: /branches/GrammaticalEvolution/HeuristicLab.Problems.GrammaticalEvolution/Mappers/BreathFirstMapper.cs
===================================================================
--- /branches/GrammaticalEvolution/HeuristicLab.Problems.GrammaticalEvolution/Mappers/BreathFirstMapper.cs	(revision 10067)
+++ /branches/GrammaticalEvolution/HeuristicLab.Problems.GrammaticalEvolution/Mappers/BreathFirstMapper.cs	(revision 10068)
@@ -20,5 +20,4 @@
 #endregion
 
-using System;
 using HeuristicLab.Common;
 using HeuristicLab.Core;
@@ -34,5 +33,5 @@
   [StorableClass]
   public class BreathFirstMapper : GenotypeToPhenotypeMapper {
-    
+
     [StorableConstructor]
     protected BreathFirstMapper(bool deserializing) : base(deserializing) { }
@@ -43,6 +42,6 @@
       return new BreathFirstMapper(this, cloner);
     }
-    
-    
+
+
     /// <summary>
     /// Maps a genotype (an integer vector) to a phenotype (a symbolic expression tree).
@@ -54,13 +53,13 @@
     public override SymbolicExpressionTree Map(ISymbolicExpressionGrammar grammar,
                                                IntegerVector genotype) {
-      
+
       SymbolicExpressionTree tree = new SymbolicExpressionTree();
-      var rootNode  = (SymbolicExpressionTreeTopLevelNode)grammar.ProgramRootSymbol.CreateTreeNode();
+      var rootNode = (SymbolicExpressionTreeTopLevelNode)grammar.ProgramRootSymbol.CreateTreeNode();
       var startNode = (SymbolicExpressionTreeTopLevelNode)grammar.StartSymbol.CreateTreeNode();
       rootNode.AddSubtree(startNode);
       tree.Root = rootNode;
-      
+
       // TODO
-     
+
       return tree;
     }
Index: /branches/GrammaticalEvolution/HeuristicLab.Problems.GrammaticalEvolution/Mappers/DepthFirstMapper.cs
===================================================================
--- /branches/GrammaticalEvolution/HeuristicLab.Problems.GrammaticalEvolution/Mappers/DepthFirstMapper.cs	(revision 10067)
+++ /branches/GrammaticalEvolution/HeuristicLab.Problems.GrammaticalEvolution/Mappers/DepthFirstMapper.cs	(revision 10068)
@@ -20,5 +20,4 @@
 #endregion
 
-using System;
 using HeuristicLab.Common;
 using HeuristicLab.Core;
@@ -34,5 +33,5 @@
   [StorableClass]
   public class DepthFirstMapper : GenotypeToPhenotypeMapper {
-    
+
     [StorableConstructor]
     protected DepthFirstMapper(bool deserializing) : base(deserializing) { }
@@ -43,6 +42,6 @@
       return new DepthFirstMapper(this, cloner);
     }
-    
-    
+
+
     /// <summary>
     /// Maps a genotype (an integer vector) to a phenotype (a symbolic expression tree).
@@ -54,22 +53,22 @@
     public override SymbolicExpressionTree Map(ISymbolicExpressionGrammar grammar,
                                                IntegerVector genotype) {
-      
+
       SymbolicExpressionTree tree = new SymbolicExpressionTree();
-      var rootNode  = (SymbolicExpressionTreeTopLevelNode)grammar.ProgramRootSymbol.CreateTreeNode();
+      var rootNode = (SymbolicExpressionTreeTopLevelNode)grammar.ProgramRootSymbol.CreateTreeNode();
       var startNode = (SymbolicExpressionTreeTopLevelNode)grammar.StartSymbol.CreateTreeNode();
       rootNode.AddSubtree(startNode);
       tree.Root = rootNode;
-      
-      int genotypeIndex    = 0;
+
+      int genotypeIndex = 0;
       int currSubtreeCount = 1;
-      
+
       MapDepthFirstRecursively(startNode, genotype,
                                grammar, genotype.Length,
                                ref genotypeIndex, ref currSubtreeCount);
-     
+
       return tree;
     }
-    
-    
+
+
     /// <summary>
     /// Genotype-to-Phenotype mapper (recursive depth-first approach).
@@ -93,8 +92,8 @@
                                           ref int genotypeIndex,
                                           ref int currSubtreeCount) {
-    	if (currSubtreeCount < maxSubtreeCount) {
-    	
+      if (currSubtreeCount < maxSubtreeCount) {
+
         var newNode = GetNewChildNode(currentNode, genotype, grammar, genotypeIndex);
-        
+
         if ((currSubtreeCount + newNode.Symbol.MaximumArity) > maxSubtreeCount) {
           // TODO: maybe check, if there is any node, which fits in the tree yet
@@ -102,14 +101,14 @@
         } else {
           currentNode.AddSubtree(newNode);
-    		  genotypeIndex++;
-	    	  currSubtreeCount += newNode.Symbol.MaximumArity;
-	    	
-	    	  while (newNode.Symbol.MaximumArity > newNode.SubtreeCount) {
-	    		  MapDepthFirstRecursively(newNode, genotype, 
-	    	                             grammar, maxSubtreeCount,
-	    	                             ref genotypeIndex, ref currSubtreeCount);
-	    	  }
+          genotypeIndex++;
+          currSubtreeCount += newNode.Symbol.MaximumArity;
+
+          while (newNode.Symbol.MaximumArity > newNode.SubtreeCount) {
+            MapDepthFirstRecursively(newNode, genotype,
+                                     grammar, maxSubtreeCount,
+                                     ref genotypeIndex, ref currSubtreeCount);
+          }
         }
-        
+
       } else {
         while (currentNode.Symbol.MaximumArity > currentNode.SubtreeCount) {
Index: /branches/GrammaticalEvolution/HeuristicLab.Problems.GrammaticalEvolution/Mappers/GenotypeToPhenotypeMapper.cs
===================================================================
--- /branches/GrammaticalEvolution/HeuristicLab.Problems.GrammaticalEvolution/Mappers/GenotypeToPhenotypeMapper.cs	(revision 10067)
+++ /branches/GrammaticalEvolution/HeuristicLab.Problems.GrammaticalEvolution/Mappers/GenotypeToPhenotypeMapper.cs	(revision 10068)
@@ -34,13 +34,13 @@
   /// </summary>
   public abstract class GenotypeToPhenotypeMapper : IntegerVectorOperator, IGenotypeToPhenotypeMapper {
-    
+
     [StorableConstructor]
     protected GenotypeToPhenotypeMapper(bool deserializing) : base(deserializing) { }
     protected GenotypeToPhenotypeMapper(GenotypeToPhenotypeMapper original, Cloner cloner) : base(original, cloner) { }
     protected GenotypeToPhenotypeMapper() : base() { }
-    
+
     public abstract SymbolicExpressionTree Map(ISymbolicExpressionGrammar grammar,
                                                IntegerVector genotype);
-    
+
     /// <summary>
     /// Randomly returns a terminal node for the given <paramref name="parentNode"/>.
@@ -51,14 +51,14 @@
     /// <returns>randomly chosen terminal node with arity 0</returns>
     protected ISymbolicExpressionTreeNode GetRandomTerminalNode(ISymbolicExpressionTreeNode parentNode,
-                                                              ISymbolicExpressionGrammar  grammar) {
-      var possibleSymbolsList = from   s in grammar.GetAllowedChildSymbols(parentNode.Symbol)
-                                where  s.MaximumArity == 0
-                                where  s.MinimumArity == 0
+                                                              ISymbolicExpressionGrammar grammar) {
+      var possibleSymbolsList = from s in grammar.GetAllowedChildSymbols(parentNode.Symbol)
+                                where s.MaximumArity == 0
+                                where s.MinimumArity == 0
                                 select s;
       // TODO: Check, if symbol list is empty (no terminal nodes found) - what should happen? 
       return possibleSymbolsList.SelectRandom(new MersenneTwister()).CreateTreeNode();
     }
-    
-    
+
+
     /// <summary>
     /// Returns a randomly chosen child node for the given <paramref name="parentNode"/>.
@@ -73,9 +73,9 @@
                                                           ISymbolicExpressionGrammar grammar,
                                                           int genotypeIndex) {
-      
+
       IEnumerable<ISymbol> symbolList = grammar.GetAllowedChildSymbols(parentNode.Symbol);
       int prodRuleCount = symbolList.Count();
       int prodRuleIndex = genotype[genotypeIndex % genotype.Length] % prodRuleCount;
-      
+
       return symbolList.ElementAt(prodRuleIndex).CreateTreeNode();
     }
Index: /branches/GrammaticalEvolution/HeuristicLab.Problems.GrammaticalEvolution/Mappers/IGenotypeToPhenotypeMapper.cs
===================================================================
--- /branches/GrammaticalEvolution/HeuristicLab.Problems.GrammaticalEvolution/Mappers/IGenotypeToPhenotypeMapper.cs	(revision 10067)
+++ /branches/GrammaticalEvolution/HeuristicLab.Problems.GrammaticalEvolution/Mappers/IGenotypeToPhenotypeMapper.cs	(revision 10068)
@@ -20,5 +20,4 @@
 #endregion
 
-using System;
 using HeuristicLab.Encodings.IntegerVectorEncoding;
 using HeuristicLab.Encodings.SymbolicExpressionTreeEncoding;
Index: /branches/GrammaticalEvolution/HeuristicLab.Problems.GrammaticalEvolution/Mappers/PIGEMapper.cs
===================================================================
--- /branches/GrammaticalEvolution/HeuristicLab.Problems.GrammaticalEvolution/Mappers/PIGEMapper.cs	(revision 10067)
+++ /branches/GrammaticalEvolution/HeuristicLab.Problems.GrammaticalEvolution/Mappers/PIGEMapper.cs	(revision 10068)
@@ -20,5 +20,4 @@
 #endregion
 
-using System;
 using HeuristicLab.Common;
 using HeuristicLab.Core;
@@ -29,10 +28,10 @@
 namespace HeuristicLab.Problems.GrammaticalEvolution {
   /// <summary>
-  /// PIGEMapper
+  /// Position Independent (PI) Grammatical Evolution Mapper
   /// </summary>
   [Item("PIGEMapper", "")]
   [StorableClass]
   public class PIGEMapper : GenotypeToPhenotypeMapper {
-    
+
     [StorableConstructor]
     protected PIGEMapper(bool deserializing) : base(deserializing) { }
@@ -43,6 +42,6 @@
       return new PIGEMapper(this, cloner);
     }
-    
-    
+
+
     /// <summary>
     /// Maps a genotype (an integer vector) to a phenotype (a symbolic expression tree).
@@ -54,13 +53,13 @@
     public override SymbolicExpressionTree Map(ISymbolicExpressionGrammar grammar,
                                                IntegerVector genotype) {
-      
+
       SymbolicExpressionTree tree = new SymbolicExpressionTree();
-      var rootNode  = (SymbolicExpressionTreeTopLevelNode)grammar.ProgramRootSymbol.CreateTreeNode();
+      var rootNode = (SymbolicExpressionTreeTopLevelNode)grammar.ProgramRootSymbol.CreateTreeNode();
       var startNode = (SymbolicExpressionTreeTopLevelNode)grammar.StartSymbol.CreateTreeNode();
       rootNode.AddSubtree(startNode);
       tree.Root = rootNode;
-      
+
       // TODO
-     
+
       return tree;
     }
Index: /branches/GrammaticalEvolution/HeuristicLab.Problems.GrammaticalEvolution/Mappers/RandomMapper.cs
===================================================================
--- /branches/GrammaticalEvolution/HeuristicLab.Problems.GrammaticalEvolution/Mappers/RandomMapper.cs	(revision 10067)
+++ /branches/GrammaticalEvolution/HeuristicLab.Problems.GrammaticalEvolution/Mappers/RandomMapper.cs	(revision 10068)
@@ -20,5 +20,4 @@
 #endregion
 
-using System;
 using HeuristicLab.Common;
 using HeuristicLab.Core;
@@ -34,5 +33,5 @@
   [StorableClass]
   public class RandomMapper : GenotypeToPhenotypeMapper {
-    
+
     [StorableConstructor]
     protected RandomMapper(bool deserializing) : base(deserializing) { }
@@ -43,6 +42,6 @@
       return new RandomMapper(this, cloner);
     }
-    
-    
+
+
     /// <summary>
     /// Maps a genotype (an integer vector) to a phenotype (a symbolic expression tree).
@@ -54,13 +53,13 @@
     public override SymbolicExpressionTree Map(ISymbolicExpressionGrammar grammar,
                                                IntegerVector genotype) {
-      
+
       SymbolicExpressionTree tree = new SymbolicExpressionTree();
-      var rootNode  = (SymbolicExpressionTreeTopLevelNode)grammar.ProgramRootSymbol.CreateTreeNode();
+      var rootNode = (SymbolicExpressionTreeTopLevelNode)grammar.ProgramRootSymbol.CreateTreeNode();
       var startNode = (SymbolicExpressionTreeTopLevelNode)grammar.StartSymbol.CreateTreeNode();
       rootNode.AddSubtree(startNode);
       tree.Root = rootNode;
-      
+
       // TODO
-     
+
       return tree;
     }