Index: branches/HeuristicLab.Problems.GPDL/Examples/Artificial Ant.txt
===================================================================
--- branches/HeuristicLab.Problems.GPDL/Examples/Artificial Ant.txt	(revision 10079)
+++ branches/HeuristicLab.Problems.GPDL/Examples/Artificial Ant.txt	(revision 10080)
@@ -6,5 +6,5 @@
   public Point(int x, int y) {
     this.x = x;
-	this.y = y;
+    this.y = y;
   }
 };
@@ -95,10 +95,10 @@
     if(p.x < 0 || p.y < 0) return false;
     if(world.Length <= p.y) return false;
-	if(world[p.y].Length <= p.x) return false;
+    if(world[p.y].Length <= p.x) return false;
     return world[p.y][p.x] == '#';
   }
   public void RemoveFoodAt(Point p) {
     if(world.Length < p.y) return;
-	if(world[p.y].Length < p.x) return;
+    if(world[p.y].Length < p.x) return;
     world[p.y][p.x] = ' ';
   }
@@ -116,6 +116,6 @@
  
   public AntState() {
-    Steps = 0;	
-	FoodEaten = 0;
+    Steps = 0;    
+    FoodEaten = 0;
   }
  
@@ -123,49 +123,49 @@
     Steps++;
     switch(Direction) {
-	  case Direction.West: Direction = Direction.South; break;
-	  case Direction.South: Direction = Direction.East; break;
-	  case Direction.East: Direction = Direction.North; break;
-	  case Direction.North: Direction = Direction.West; break;
-	}
+      case Direction.West: Direction = Direction.South; break;
+      case Direction.South: Direction = Direction.East; break;
+      case Direction.East: Direction = Direction.North; break;
+      case Direction.North: Direction = Direction.West; break;
+    }
   }
   public void TurnRight() {
     Steps++;
     switch(Direction) {
-	  case Direction.West: Direction = Direction.North; break;
-	  case Direction.South: Direction = Direction.West; break;
-	  case Direction.East: Direction = Direction.South; break;
-	  case Direction.North: Direction = Direction.East; break;
-	}
+      case Direction.West: Direction = Direction.North; break;
+      case Direction.South: Direction = Direction.West; break;
+      case Direction.East: Direction = Direction.South; break;
+      case Direction.North: Direction = Direction.East; break;
+    }
   }
   public void MoveForward() { 
     Position = NextPosition; 
-	Steps++; 
-	if(World.FoodAt(Position)) {
-    	World.RemoveFoodAt(Position);
-		FoodEaten++;
+    Steps++; 
+    if(World.FoodAt(Position)) {
+        World.RemoveFoodAt(Position);
+        FoodEaten++;
     }
   }
   public Point NextPosition { 
     get { 
-	    int x, y;
+        int x, y;
         switch(Direction) {
-    	  case Direction.West: 
-		    x = (Position.x + World.Width - 1) % World.Width;
-			y = Position.y;
-			return new Point(x, y);
-    	  case Direction.South: 
-  		    x = Position.x;
-			y = (Position.y + World.Height + 1) % World.Height;
-			return new Point(x, y);
-    	  case Direction.East:
-  		    x = (Position.x + World.Width + 1) % World.Width;
-			y = Position.y;
-			return new Point(x, y);
-    	  case Direction.North:
-  		    x = Position.x;
-			y = (Position.y + World.Height - 1) % World.Height;
-			return new Point(x, y);
-    	}
- 		return new Point(-1,-1);
+          case Direction.West: 
+            x = (Position.x + World.Width - 1) % World.Width;
+            y = Position.y;
+            return new Point(x, y);
+          case Direction.South: 
+              x = Position.x;
+            y = (Position.y + World.Height + 1) % World.Height;
+            return new Point(x, y);
+          case Direction.East:
+              x = (Position.x + World.Width + 1) % World.Width;
+            y = Position.y;
+            return new Point(x, y);
+          case Direction.North:
+              x = Position.x;
+            y = (Position.y + World.Height - 1) % World.Height;
+            return new Point(x, y);
+        }
+         return new Point(-1,-1);
     } 
   }  
Index: branches/HeuristicLab.Problems.GPDL/Examples/RoyalTree.txt
===================================================================
--- branches/HeuristicLab.Problems.GPDL/Examples/RoyalTree.txt	(revision 10079)
+++ branches/HeuristicLab.Problems.GPDL/Examples/RoyalTree.txt	(revision 10080)
@@ -1,6 +1,6 @@
 /* The Royal Tree benchmark problem for GP */
 /* See paper: William F. Punch, How Effective are Multiple Populations in Genetic Programming */
-/* 
 /* for max. depth 7 (level: g) this is hard to solve. Full enumeration needs a lot of memory. */
+
 PROBLEM RoyalTree
 CODE <<